// Code generated by SQLBoiler 4.14.2 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/friendsofgo/errors"
	"github.com/volatiletech/null/v8"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/sqlboiler/v4/queries/qm"
	"github.com/volatiletech/sqlboiler/v4/queries/qmhelper"
	"github.com/volatiletech/strmangle"
)

// OrderVehicle is an object representing the database table.
type OrderVehicle struct {
	ID                int64       `boil:"id" json:"id" toml:"id" yaml:"id"`
	ProductName       null.String `boil:"product_name" json:"product_name,omitempty" toml:"product_name" yaml:"product_name,omitempty"`
	LicensePlate      null.String `boil:"license_plate" json:"license_plate,omitempty" toml:"license_plate" yaml:"license_plate,omitempty"`
	AddPayments       null.Int    `boil:"add_payments" json:"add_payments,omitempty" toml:"add_payments" yaml:"add_payments,omitempty"`
	Note              null.String `boil:"note" json:"note,omitempty" toml:"note" yaml:"note,omitempty"`
	Miss              null.Int    `boil:"miss" json:"miss,omitempty" toml:"miss" yaml:"miss,omitempty"`
	PriceOld          null.Int    `boil:"price_old" json:"price_old,omitempty" toml:"price_old" yaml:"price_old,omitempty"`
	Price             null.Int    `boil:"price" json:"price,omitempty" toml:"price" yaml:"price,omitempty"`
	OrderDate         null.Time   `boil:"order_date" json:"order_date,omitempty" toml:"order_date" yaml:"order_date,omitempty"`
	Percent           null.Int64  `boil:"percent" json:"percent,omitempty" toml:"percent" yaml:"percent,omitempty"`
	ReturnDate        null.Time   `boil:"return_date" json:"return_date,omitempty" toml:"return_date" yaml:"return_date,omitempty"`
	Status            null.String `boil:"status" json:"status,omitempty" toml:"status" yaml:"status,omitempty"`
	InterestPaidCount null.Int    `boil:"interest_paid_count" json:"interest_paid_count,omitempty" toml:"interest_paid_count" yaml:"interest_paid_count,omitempty"`
	CustomerID        null.Int64  `boil:"customer_id" json:"customer_id,omitempty" toml:"customer_id" yaml:"customer_id,omitempty"`
	CreatedAt         time.Time   `boil:"created_at" json:"created_at" toml:"created_at" yaml:"created_at"`
	UpdatedAt         time.Time   `boil:"updated_at" json:"updated_at" toml:"updated_at" yaml:"updated_at"`

	R *orderVehicleR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L orderVehicleL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var OrderVehicleColumns = struct {
	ID                string
	ProductName       string
	LicensePlate      string
	AddPayments       string
	Note              string
	Miss              string
	PriceOld          string
	Price             string
	OrderDate         string
	Percent           string
	ReturnDate        string
	Status            string
	InterestPaidCount string
	CustomerID        string
	CreatedAt         string
	UpdatedAt         string
}{
	ID:                "id",
	ProductName:       "product_name",
	LicensePlate:      "license_plate",
	AddPayments:       "add_payments",
	Note:              "note",
	Miss:              "miss",
	PriceOld:          "price_old",
	Price:             "price",
	OrderDate:         "order_date",
	Percent:           "percent",
	ReturnDate:        "return_date",
	Status:            "status",
	InterestPaidCount: "interest_paid_count",
	CustomerID:        "customer_id",
	CreatedAt:         "created_at",
	UpdatedAt:         "updated_at",
}

var OrderVehicleTableColumns = struct {
	ID                string
	ProductName       string
	LicensePlate      string
	AddPayments       string
	Note              string
	Miss              string
	PriceOld          string
	Price             string
	OrderDate         string
	Percent           string
	ReturnDate        string
	Status            string
	InterestPaidCount string
	CustomerID        string
	CreatedAt         string
	UpdatedAt         string
}{
	ID:                "order_vehicle.id",
	ProductName:       "order_vehicle.product_name",
	LicensePlate:      "order_vehicle.license_plate",
	AddPayments:       "order_vehicle.add_payments",
	Note:              "order_vehicle.note",
	Miss:              "order_vehicle.miss",
	PriceOld:          "order_vehicle.price_old",
	Price:             "order_vehicle.price",
	OrderDate:         "order_vehicle.order_date",
	Percent:           "order_vehicle.percent",
	ReturnDate:        "order_vehicle.return_date",
	Status:            "order_vehicle.status",
	InterestPaidCount: "order_vehicle.interest_paid_count",
	CustomerID:        "order_vehicle.customer_id",
	CreatedAt:         "order_vehicle.created_at",
	UpdatedAt:         "order_vehicle.updated_at",
}

// Generated where

var OrderVehicleWhere = struct {
	ID                whereHelperint64
	ProductName       whereHelpernull_String
	LicensePlate      whereHelpernull_String
	AddPayments       whereHelpernull_Int
	Note              whereHelpernull_String
	Miss              whereHelpernull_Int
	PriceOld          whereHelpernull_Int
	Price             whereHelpernull_Int
	OrderDate         whereHelpernull_Time
	Percent           whereHelpernull_Int64
	ReturnDate        whereHelpernull_Time
	Status            whereHelpernull_String
	InterestPaidCount whereHelpernull_Int
	CustomerID        whereHelpernull_Int64
	CreatedAt         whereHelpertime_Time
	UpdatedAt         whereHelpertime_Time
}{
	ID:                whereHelperint64{field: "\"order_vehicle\".\"id\""},
	ProductName:       whereHelpernull_String{field: "\"order_vehicle\".\"product_name\""},
	LicensePlate:      whereHelpernull_String{field: "\"order_vehicle\".\"license_plate\""},
	AddPayments:       whereHelpernull_Int{field: "\"order_vehicle\".\"add_payments\""},
	Note:              whereHelpernull_String{field: "\"order_vehicle\".\"note\""},
	Miss:              whereHelpernull_Int{field: "\"order_vehicle\".\"miss\""},
	PriceOld:          whereHelpernull_Int{field: "\"order_vehicle\".\"price_old\""},
	Price:             whereHelpernull_Int{field: "\"order_vehicle\".\"price\""},
	OrderDate:         whereHelpernull_Time{field: "\"order_vehicle\".\"order_date\""},
	Percent:           whereHelpernull_Int64{field: "\"order_vehicle\".\"percent\""},
	ReturnDate:        whereHelpernull_Time{field: "\"order_vehicle\".\"return_date\""},
	Status:            whereHelpernull_String{field: "\"order_vehicle\".\"status\""},
	InterestPaidCount: whereHelpernull_Int{field: "\"order_vehicle\".\"interest_paid_count\""},
	CustomerID:        whereHelpernull_Int64{field: "\"order_vehicle\".\"customer_id\""},
	CreatedAt:         whereHelpertime_Time{field: "\"order_vehicle\".\"created_at\""},
	UpdatedAt:         whereHelpertime_Time{field: "\"order_vehicle\".\"updated_at\""},
}

// OrderVehicleRels is where relationship names are stored.
var OrderVehicleRels = struct {
	Customer                      string
	PercentCategoryPercent        string
	IDVehicleAddPaymentsVehicles  string
	OrderInterestPaymentsVehicles string
	OrderRedeemOrderVehicles      string
}{
	Customer:                      "Customer",
	PercentCategoryPercent:        "PercentCategoryPercent",
	IDVehicleAddPaymentsVehicles:  "IDVehicleAddPaymentsVehicles",
	OrderInterestPaymentsVehicles: "OrderInterestPaymentsVehicles",
	OrderRedeemOrderVehicles:      "OrderRedeemOrderVehicles",
}

// orderVehicleR is where relationships are stored.
type orderVehicleR struct {
	Customer                      *Customer                    `boil:"Customer" json:"Customer" toml:"Customer" yaml:"Customer"`
	PercentCategoryPercent        *CategoryPercent             `boil:"PercentCategoryPercent" json:"PercentCategoryPercent" toml:"PercentCategoryPercent" yaml:"PercentCategoryPercent"`
	IDVehicleAddPaymentsVehicles  AddPaymentsVehicleSlice      `boil:"IDVehicleAddPaymentsVehicles" json:"IDVehicleAddPaymentsVehicles" toml:"IDVehicleAddPaymentsVehicles" yaml:"IDVehicleAddPaymentsVehicles"`
	OrderInterestPaymentsVehicles InterestPaymentsVehicleSlice `boil:"OrderInterestPaymentsVehicles" json:"OrderInterestPaymentsVehicles" toml:"OrderInterestPaymentsVehicles" yaml:"OrderInterestPaymentsVehicles"`
	OrderRedeemOrderVehicles      RedeemOrderVehicleSlice      `boil:"OrderRedeemOrderVehicles" json:"OrderRedeemOrderVehicles" toml:"OrderRedeemOrderVehicles" yaml:"OrderRedeemOrderVehicles"`
}

// NewStruct creates a new relationship struct
func (*orderVehicleR) NewStruct() *orderVehicleR {
	return &orderVehicleR{}
}

func (r *orderVehicleR) GetCustomer() *Customer {
	if r == nil {
		return nil
	}
	return r.Customer
}

func (r *orderVehicleR) GetPercentCategoryPercent() *CategoryPercent {
	if r == nil {
		return nil
	}
	return r.PercentCategoryPercent
}

func (r *orderVehicleR) GetIDVehicleAddPaymentsVehicles() AddPaymentsVehicleSlice {
	if r == nil {
		return nil
	}
	return r.IDVehicleAddPaymentsVehicles
}

func (r *orderVehicleR) GetOrderInterestPaymentsVehicles() InterestPaymentsVehicleSlice {
	if r == nil {
		return nil
	}
	return r.OrderInterestPaymentsVehicles
}

func (r *orderVehicleR) GetOrderRedeemOrderVehicles() RedeemOrderVehicleSlice {
	if r == nil {
		return nil
	}
	return r.OrderRedeemOrderVehicles
}

// orderVehicleL is where Load methods for each relationship are stored.
type orderVehicleL struct{}

var (
	orderVehicleAllColumns            = []string{"id", "product_name", "license_plate", "add_payments", "note", "miss", "price_old", "price", "order_date", "percent", "return_date", "status", "interest_paid_count", "customer_id", "created_at", "updated_at"}
	orderVehicleColumnsWithoutDefault = []string{}
	orderVehicleColumnsWithDefault    = []string{"id", "product_name", "license_plate", "add_payments", "note", "miss", "price_old", "price", "order_date", "percent", "return_date", "status", "interest_paid_count", "customer_id", "created_at", "updated_at"}
	orderVehiclePrimaryKeyColumns     = []string{"id"}
	orderVehicleGeneratedColumns      = []string{}
)

type (
	// OrderVehicleSlice is an alias for a slice of pointers to OrderVehicle.
	// This should almost always be used instead of []OrderVehicle.
	OrderVehicleSlice []*OrderVehicle
	// OrderVehicleHook is the signature for custom OrderVehicle hook methods
	OrderVehicleHook func(context.Context, boil.ContextExecutor, *OrderVehicle) error

	orderVehicleQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	orderVehicleType                 = reflect.TypeOf(&OrderVehicle{})
	orderVehicleMapping              = queries.MakeStructMapping(orderVehicleType)
	orderVehiclePrimaryKeyMapping, _ = queries.BindMapping(orderVehicleType, orderVehicleMapping, orderVehiclePrimaryKeyColumns)
	orderVehicleInsertCacheMut       sync.RWMutex
	orderVehicleInsertCache          = make(map[string]insertCache)
	orderVehicleUpdateCacheMut       sync.RWMutex
	orderVehicleUpdateCache          = make(map[string]updateCache)
	orderVehicleUpsertCacheMut       sync.RWMutex
	orderVehicleUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var orderVehicleAfterSelectHooks []OrderVehicleHook

var orderVehicleBeforeInsertHooks []OrderVehicleHook
var orderVehicleAfterInsertHooks []OrderVehicleHook

var orderVehicleBeforeUpdateHooks []OrderVehicleHook
var orderVehicleAfterUpdateHooks []OrderVehicleHook

var orderVehicleBeforeDeleteHooks []OrderVehicleHook
var orderVehicleAfterDeleteHooks []OrderVehicleHook

var orderVehicleBeforeUpsertHooks []OrderVehicleHook
var orderVehicleAfterUpsertHooks []OrderVehicleHook

// doAfterSelectHooks executes all "after Select" hooks.
func (o *OrderVehicle) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderVehicleAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *OrderVehicle) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderVehicleBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *OrderVehicle) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderVehicleAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *OrderVehicle) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderVehicleBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *OrderVehicle) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderVehicleAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *OrderVehicle) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderVehicleBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *OrderVehicle) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderVehicleAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *OrderVehicle) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderVehicleBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *OrderVehicle) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderVehicleAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddOrderVehicleHook registers your hook function for all future operations.
func AddOrderVehicleHook(hookPoint boil.HookPoint, orderVehicleHook OrderVehicleHook) {
	switch hookPoint {
	case boil.AfterSelectHook:
		orderVehicleAfterSelectHooks = append(orderVehicleAfterSelectHooks, orderVehicleHook)
	case boil.BeforeInsertHook:
		orderVehicleBeforeInsertHooks = append(orderVehicleBeforeInsertHooks, orderVehicleHook)
	case boil.AfterInsertHook:
		orderVehicleAfterInsertHooks = append(orderVehicleAfterInsertHooks, orderVehicleHook)
	case boil.BeforeUpdateHook:
		orderVehicleBeforeUpdateHooks = append(orderVehicleBeforeUpdateHooks, orderVehicleHook)
	case boil.AfterUpdateHook:
		orderVehicleAfterUpdateHooks = append(orderVehicleAfterUpdateHooks, orderVehicleHook)
	case boil.BeforeDeleteHook:
		orderVehicleBeforeDeleteHooks = append(orderVehicleBeforeDeleteHooks, orderVehicleHook)
	case boil.AfterDeleteHook:
		orderVehicleAfterDeleteHooks = append(orderVehicleAfterDeleteHooks, orderVehicleHook)
	case boil.BeforeUpsertHook:
		orderVehicleBeforeUpsertHooks = append(orderVehicleBeforeUpsertHooks, orderVehicleHook)
	case boil.AfterUpsertHook:
		orderVehicleAfterUpsertHooks = append(orderVehicleAfterUpsertHooks, orderVehicleHook)
	}
}

// One returns a single orderVehicle record from the query.
func (q orderVehicleQuery) One(ctx context.Context, exec boil.ContextExecutor) (*OrderVehicle, error) {
	o := &OrderVehicle{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: failed to execute a one query for order_vehicle")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all OrderVehicle records from the query.
func (q orderVehicleQuery) All(ctx context.Context, exec boil.ContextExecutor) (OrderVehicleSlice, error) {
	var o []*OrderVehicle

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "models: failed to assign all query results to OrderVehicle slice")
	}

	if len(orderVehicleAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all OrderVehicle records in the query.
func (q orderVehicleQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to count order_vehicle rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q orderVehicleQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "models: failed to check if order_vehicle exists")
	}

	return count > 0, nil
}

// Customer pointed to by the foreign key.
func (o *OrderVehicle) Customer(mods ...qm.QueryMod) customerQuery {
	queryMods := []qm.QueryMod{
		qm.Where("\"customer_id\" = ?", o.CustomerID),
	}

	queryMods = append(queryMods, mods...)

	return Customers(queryMods...)
}

// PercentCategoryPercent pointed to by the foreign key.
func (o *OrderVehicle) PercentCategoryPercent(mods ...qm.QueryMod) categoryPercentQuery {
	queryMods := []qm.QueryMod{
		qm.Where("\"percent_id\" = ?", o.Percent),
	}

	queryMods = append(queryMods, mods...)

	return CategoryPercents(queryMods...)
}

// IDVehicleAddPaymentsVehicles retrieves all the add_payments_vehicle's AddPaymentsVehicles with an executor via id_vehicle column.
func (o *OrderVehicle) IDVehicleAddPaymentsVehicles(mods ...qm.QueryMod) addPaymentsVehicleQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"add_payments_vehicle\".\"id_vehicle\"=?", o.ID),
	)

	return AddPaymentsVehicles(queryMods...)
}

// OrderInterestPaymentsVehicles retrieves all the interest_payments_vehicle's InterestPaymentsVehicles with an executor via order_id column.
func (o *OrderVehicle) OrderInterestPaymentsVehicles(mods ...qm.QueryMod) interestPaymentsVehicleQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"interest_payments_vehicle\".\"order_id\"=?", o.ID),
	)

	return InterestPaymentsVehicles(queryMods...)
}

// OrderRedeemOrderVehicles retrieves all the redeem_order_vehicle's RedeemOrderVehicles with an executor via order_id column.
func (o *OrderVehicle) OrderRedeemOrderVehicles(mods ...qm.QueryMod) redeemOrderVehicleQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"redeem_order_vehicle\".\"order_id\"=?", o.ID),
	)

	return RedeemOrderVehicles(queryMods...)
}

// LoadCustomer allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (orderVehicleL) LoadCustomer(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderVehicle interface{}, mods queries.Applicator) error {
	var slice []*OrderVehicle
	var object *OrderVehicle

	if singular {
		var ok bool
		object, ok = maybeOrderVehicle.(*OrderVehicle)
		if !ok {
			object = new(OrderVehicle)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderVehicle))
			}
		}
	} else {
		s, ok := maybeOrderVehicle.(*[]*OrderVehicle)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderVehicle))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderVehicleR{}
		}
		if !queries.IsNil(object.CustomerID) {
			args = append(args, object.CustomerID)
		}

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderVehicleR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.CustomerID) {
					continue Outer
				}
			}

			if !queries.IsNil(obj.CustomerID) {
				args = append(args, obj.CustomerID)
			}

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`customers`),
		qm.WhereIn(`customers.customer_id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load Customer")
	}

	var resultSlice []*Customer
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice Customer")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for customers")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for customers")
	}

	if len(customerAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.Customer = foreign
		if foreign.R == nil {
			foreign.R = &customerR{}
		}
		foreign.R.OrderVehicles = append(foreign.R.OrderVehicles, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if queries.Equal(local.CustomerID, foreign.CustomerID) {
				local.R.Customer = foreign
				if foreign.R == nil {
					foreign.R = &customerR{}
				}
				foreign.R.OrderVehicles = append(foreign.R.OrderVehicles, local)
				break
			}
		}
	}

	return nil
}

// LoadPercentCategoryPercent allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (orderVehicleL) LoadPercentCategoryPercent(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderVehicle interface{}, mods queries.Applicator) error {
	var slice []*OrderVehicle
	var object *OrderVehicle

	if singular {
		var ok bool
		object, ok = maybeOrderVehicle.(*OrderVehicle)
		if !ok {
			object = new(OrderVehicle)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderVehicle))
			}
		}
	} else {
		s, ok := maybeOrderVehicle.(*[]*OrderVehicle)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderVehicle))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderVehicleR{}
		}
		if !queries.IsNil(object.Percent) {
			args = append(args, object.Percent)
		}

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderVehicleR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.Percent) {
					continue Outer
				}
			}

			if !queries.IsNil(obj.Percent) {
				args = append(args, obj.Percent)
			}

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`category_percent`),
		qm.WhereIn(`category_percent.percent_id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load CategoryPercent")
	}

	var resultSlice []*CategoryPercent
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice CategoryPercent")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for category_percent")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for category_percent")
	}

	if len(categoryPercentAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.PercentCategoryPercent = foreign
		if foreign.R == nil {
			foreign.R = &categoryPercentR{}
		}
		foreign.R.PercentOrderVehicles = append(foreign.R.PercentOrderVehicles, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if queries.Equal(local.Percent, foreign.PercentID) {
				local.R.PercentCategoryPercent = foreign
				if foreign.R == nil {
					foreign.R = &categoryPercentR{}
				}
				foreign.R.PercentOrderVehicles = append(foreign.R.PercentOrderVehicles, local)
				break
			}
		}
	}

	return nil
}

// LoadIDVehicleAddPaymentsVehicles allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (orderVehicleL) LoadIDVehicleAddPaymentsVehicles(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderVehicle interface{}, mods queries.Applicator) error {
	var slice []*OrderVehicle
	var object *OrderVehicle

	if singular {
		var ok bool
		object, ok = maybeOrderVehicle.(*OrderVehicle)
		if !ok {
			object = new(OrderVehicle)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderVehicle))
			}
		}
	} else {
		s, ok := maybeOrderVehicle.(*[]*OrderVehicle)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderVehicle))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderVehicleR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderVehicleR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.ID) {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`add_payments_vehicle`),
		qm.WhereIn(`add_payments_vehicle.id_vehicle in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load add_payments_vehicle")
	}

	var resultSlice []*AddPaymentsVehicle
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice add_payments_vehicle")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on add_payments_vehicle")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for add_payments_vehicle")
	}

	if len(addPaymentsVehicleAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.IDVehicleAddPaymentsVehicles = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &addPaymentsVehicleR{}
			}
			foreign.R.IDVehicleOrderVehicle = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if queries.Equal(local.ID, foreign.IDVehicle) {
				local.R.IDVehicleAddPaymentsVehicles = append(local.R.IDVehicleAddPaymentsVehicles, foreign)
				if foreign.R == nil {
					foreign.R = &addPaymentsVehicleR{}
				}
				foreign.R.IDVehicleOrderVehicle = local
				break
			}
		}
	}

	return nil
}

// LoadOrderInterestPaymentsVehicles allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (orderVehicleL) LoadOrderInterestPaymentsVehicles(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderVehicle interface{}, mods queries.Applicator) error {
	var slice []*OrderVehicle
	var object *OrderVehicle

	if singular {
		var ok bool
		object, ok = maybeOrderVehicle.(*OrderVehicle)
		if !ok {
			object = new(OrderVehicle)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderVehicle))
			}
		}
	} else {
		s, ok := maybeOrderVehicle.(*[]*OrderVehicle)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderVehicle))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderVehicleR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderVehicleR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.ID) {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`interest_payments_vehicle`),
		qm.WhereIn(`interest_payments_vehicle.order_id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load interest_payments_vehicle")
	}

	var resultSlice []*InterestPaymentsVehicle
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice interest_payments_vehicle")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on interest_payments_vehicle")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for interest_payments_vehicle")
	}

	if len(interestPaymentsVehicleAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.OrderInterestPaymentsVehicles = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &interestPaymentsVehicleR{}
			}
			foreign.R.Order = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if queries.Equal(local.ID, foreign.OrderID) {
				local.R.OrderInterestPaymentsVehicles = append(local.R.OrderInterestPaymentsVehicles, foreign)
				if foreign.R == nil {
					foreign.R = &interestPaymentsVehicleR{}
				}
				foreign.R.Order = local
				break
			}
		}
	}

	return nil
}

// LoadOrderRedeemOrderVehicles allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (orderVehicleL) LoadOrderRedeemOrderVehicles(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderVehicle interface{}, mods queries.Applicator) error {
	var slice []*OrderVehicle
	var object *OrderVehicle

	if singular {
		var ok bool
		object, ok = maybeOrderVehicle.(*OrderVehicle)
		if !ok {
			object = new(OrderVehicle)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderVehicle))
			}
		}
	} else {
		s, ok := maybeOrderVehicle.(*[]*OrderVehicle)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderVehicle))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderVehicleR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderVehicleR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.ID) {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`redeem_order_vehicle`),
		qm.WhereIn(`redeem_order_vehicle.order_id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load redeem_order_vehicle")
	}

	var resultSlice []*RedeemOrderVehicle
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice redeem_order_vehicle")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on redeem_order_vehicle")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for redeem_order_vehicle")
	}

	if len(redeemOrderVehicleAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.OrderRedeemOrderVehicles = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &redeemOrderVehicleR{}
			}
			foreign.R.Order = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if queries.Equal(local.ID, foreign.OrderID) {
				local.R.OrderRedeemOrderVehicles = append(local.R.OrderRedeemOrderVehicles, foreign)
				if foreign.R == nil {
					foreign.R = &redeemOrderVehicleR{}
				}
				foreign.R.Order = local
				break
			}
		}
	}

	return nil
}

// SetCustomer of the orderVehicle to the related item.
// Sets o.R.Customer to related.
// Adds o to related.R.OrderVehicles.
func (o *OrderVehicle) SetCustomer(ctx context.Context, exec boil.ContextExecutor, insert bool, related *Customer) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"order_vehicle\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"customer_id"}),
		strmangle.WhereClause("\"", "\"", 2, orderVehiclePrimaryKeyColumns),
	)
	values := []interface{}{related.CustomerID, o.ID}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, updateQuery)
		fmt.Fprintln(writer, values)
	}
	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	queries.Assign(&o.CustomerID, related.CustomerID)
	if o.R == nil {
		o.R = &orderVehicleR{
			Customer: related,
		}
	} else {
		o.R.Customer = related
	}

	if related.R == nil {
		related.R = &customerR{
			OrderVehicles: OrderVehicleSlice{o},
		}
	} else {
		related.R.OrderVehicles = append(related.R.OrderVehicles, o)
	}

	return nil
}

// RemoveCustomer relationship.
// Sets o.R.Customer to nil.
// Removes o from all passed in related items' relationships struct.
func (o *OrderVehicle) RemoveCustomer(ctx context.Context, exec boil.ContextExecutor, related *Customer) error {
	var err error

	queries.SetScanner(&o.CustomerID, nil)
	if _, err = o.Update(ctx, exec, boil.Whitelist("customer_id")); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	if o.R != nil {
		o.R.Customer = nil
	}
	if related == nil || related.R == nil {
		return nil
	}

	for i, ri := range related.R.OrderVehicles {
		if queries.Equal(o.CustomerID, ri.CustomerID) {
			continue
		}

		ln := len(related.R.OrderVehicles)
		if ln > 1 && i < ln-1 {
			related.R.OrderVehicles[i] = related.R.OrderVehicles[ln-1]
		}
		related.R.OrderVehicles = related.R.OrderVehicles[:ln-1]
		break
	}
	return nil
}

// SetPercentCategoryPercent of the orderVehicle to the related item.
// Sets o.R.PercentCategoryPercent to related.
// Adds o to related.R.PercentOrderVehicles.
func (o *OrderVehicle) SetPercentCategoryPercent(ctx context.Context, exec boil.ContextExecutor, insert bool, related *CategoryPercent) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"order_vehicle\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"percent"}),
		strmangle.WhereClause("\"", "\"", 2, orderVehiclePrimaryKeyColumns),
	)
	values := []interface{}{related.PercentID, o.ID}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, updateQuery)
		fmt.Fprintln(writer, values)
	}
	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	queries.Assign(&o.Percent, related.PercentID)
	if o.R == nil {
		o.R = &orderVehicleR{
			PercentCategoryPercent: related,
		}
	} else {
		o.R.PercentCategoryPercent = related
	}

	if related.R == nil {
		related.R = &categoryPercentR{
			PercentOrderVehicles: OrderVehicleSlice{o},
		}
	} else {
		related.R.PercentOrderVehicles = append(related.R.PercentOrderVehicles, o)
	}

	return nil
}

// RemovePercentCategoryPercent relationship.
// Sets o.R.PercentCategoryPercent to nil.
// Removes o from all passed in related items' relationships struct.
func (o *OrderVehicle) RemovePercentCategoryPercent(ctx context.Context, exec boil.ContextExecutor, related *CategoryPercent) error {
	var err error

	queries.SetScanner(&o.Percent, nil)
	if _, err = o.Update(ctx, exec, boil.Whitelist("percent")); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	if o.R != nil {
		o.R.PercentCategoryPercent = nil
	}
	if related == nil || related.R == nil {
		return nil
	}

	for i, ri := range related.R.PercentOrderVehicles {
		if queries.Equal(o.Percent, ri.Percent) {
			continue
		}

		ln := len(related.R.PercentOrderVehicles)
		if ln > 1 && i < ln-1 {
			related.R.PercentOrderVehicles[i] = related.R.PercentOrderVehicles[ln-1]
		}
		related.R.PercentOrderVehicles = related.R.PercentOrderVehicles[:ln-1]
		break
	}
	return nil
}

// AddIDVehicleAddPaymentsVehicles adds the given related objects to the existing relationships
// of the order_vehicle, optionally inserting them as new records.
// Appends related to o.R.IDVehicleAddPaymentsVehicles.
// Sets related.R.IDVehicleOrderVehicle appropriately.
func (o *OrderVehicle) AddIDVehicleAddPaymentsVehicles(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*AddPaymentsVehicle) error {
	var err error
	for _, rel := range related {
		if insert {
			queries.Assign(&rel.IDVehicle, o.ID)
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"add_payments_vehicle\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"id_vehicle"}),
				strmangle.WhereClause("\"", "\"", 2, addPaymentsVehiclePrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.ID}

			if boil.IsDebug(ctx) {
				writer := boil.DebugWriterFrom(ctx)
				fmt.Fprintln(writer, updateQuery)
				fmt.Fprintln(writer, values)
			}
			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			queries.Assign(&rel.IDVehicle, o.ID)
		}
	}

	if o.R == nil {
		o.R = &orderVehicleR{
			IDVehicleAddPaymentsVehicles: related,
		}
	} else {
		o.R.IDVehicleAddPaymentsVehicles = append(o.R.IDVehicleAddPaymentsVehicles, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &addPaymentsVehicleR{
				IDVehicleOrderVehicle: o,
			}
		} else {
			rel.R.IDVehicleOrderVehicle = o
		}
	}
	return nil
}

// SetIDVehicleAddPaymentsVehicles removes all previously related items of the
// order_vehicle replacing them completely with the passed
// in related items, optionally inserting them as new records.
// Sets o.R.IDVehicleOrderVehicle's IDVehicleAddPaymentsVehicles accordingly.
// Replaces o.R.IDVehicleAddPaymentsVehicles with related.
// Sets related.R.IDVehicleOrderVehicle's IDVehicleAddPaymentsVehicles accordingly.
func (o *OrderVehicle) SetIDVehicleAddPaymentsVehicles(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*AddPaymentsVehicle) error {
	query := "update \"add_payments_vehicle\" set \"id_vehicle\" = null where \"id_vehicle\" = $1"
	values := []interface{}{o.ID}
	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, query)
		fmt.Fprintln(writer, values)
	}
	_, err := exec.ExecContext(ctx, query, values...)
	if err != nil {
		return errors.Wrap(err, "failed to remove relationships before set")
	}

	if o.R != nil {
		for _, rel := range o.R.IDVehicleAddPaymentsVehicles {
			queries.SetScanner(&rel.IDVehicle, nil)
			if rel.R == nil {
				continue
			}

			rel.R.IDVehicleOrderVehicle = nil
		}
		o.R.IDVehicleAddPaymentsVehicles = nil
	}

	return o.AddIDVehicleAddPaymentsVehicles(ctx, exec, insert, related...)
}

// RemoveIDVehicleAddPaymentsVehicles relationships from objects passed in.
// Removes related items from R.IDVehicleAddPaymentsVehicles (uses pointer comparison, removal does not keep order)
// Sets related.R.IDVehicleOrderVehicle.
func (o *OrderVehicle) RemoveIDVehicleAddPaymentsVehicles(ctx context.Context, exec boil.ContextExecutor, related ...*AddPaymentsVehicle) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	for _, rel := range related {
		queries.SetScanner(&rel.IDVehicle, nil)
		if rel.R != nil {
			rel.R.IDVehicleOrderVehicle = nil
		}
		if _, err = rel.Update(ctx, exec, boil.Whitelist("id_vehicle")); err != nil {
			return err
		}
	}
	if o.R == nil {
		return nil
	}

	for _, rel := range related {
		for i, ri := range o.R.IDVehicleAddPaymentsVehicles {
			if rel != ri {
				continue
			}

			ln := len(o.R.IDVehicleAddPaymentsVehicles)
			if ln > 1 && i < ln-1 {
				o.R.IDVehicleAddPaymentsVehicles[i] = o.R.IDVehicleAddPaymentsVehicles[ln-1]
			}
			o.R.IDVehicleAddPaymentsVehicles = o.R.IDVehicleAddPaymentsVehicles[:ln-1]
			break
		}
	}

	return nil
}

// AddOrderInterestPaymentsVehicles adds the given related objects to the existing relationships
// of the order_vehicle, optionally inserting them as new records.
// Appends related to o.R.OrderInterestPaymentsVehicles.
// Sets related.R.Order appropriately.
func (o *OrderVehicle) AddOrderInterestPaymentsVehicles(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*InterestPaymentsVehicle) error {
	var err error
	for _, rel := range related {
		if insert {
			queries.Assign(&rel.OrderID, o.ID)
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"interest_payments_vehicle\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"order_id"}),
				strmangle.WhereClause("\"", "\"", 2, interestPaymentsVehiclePrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.PaymentID}

			if boil.IsDebug(ctx) {
				writer := boil.DebugWriterFrom(ctx)
				fmt.Fprintln(writer, updateQuery)
				fmt.Fprintln(writer, values)
			}
			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			queries.Assign(&rel.OrderID, o.ID)
		}
	}

	if o.R == nil {
		o.R = &orderVehicleR{
			OrderInterestPaymentsVehicles: related,
		}
	} else {
		o.R.OrderInterestPaymentsVehicles = append(o.R.OrderInterestPaymentsVehicles, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &interestPaymentsVehicleR{
				Order: o,
			}
		} else {
			rel.R.Order = o
		}
	}
	return nil
}

// SetOrderInterestPaymentsVehicles removes all previously related items of the
// order_vehicle replacing them completely with the passed
// in related items, optionally inserting them as new records.
// Sets o.R.Order's OrderInterestPaymentsVehicles accordingly.
// Replaces o.R.OrderInterestPaymentsVehicles with related.
// Sets related.R.Order's OrderInterestPaymentsVehicles accordingly.
func (o *OrderVehicle) SetOrderInterestPaymentsVehicles(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*InterestPaymentsVehicle) error {
	query := "update \"interest_payments_vehicle\" set \"order_id\" = null where \"order_id\" = $1"
	values := []interface{}{o.ID}
	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, query)
		fmt.Fprintln(writer, values)
	}
	_, err := exec.ExecContext(ctx, query, values...)
	if err != nil {
		return errors.Wrap(err, "failed to remove relationships before set")
	}

	if o.R != nil {
		for _, rel := range o.R.OrderInterestPaymentsVehicles {
			queries.SetScanner(&rel.OrderID, nil)
			if rel.R == nil {
				continue
			}

			rel.R.Order = nil
		}
		o.R.OrderInterestPaymentsVehicles = nil
	}

	return o.AddOrderInterestPaymentsVehicles(ctx, exec, insert, related...)
}

// RemoveOrderInterestPaymentsVehicles relationships from objects passed in.
// Removes related items from R.OrderInterestPaymentsVehicles (uses pointer comparison, removal does not keep order)
// Sets related.R.Order.
func (o *OrderVehicle) RemoveOrderInterestPaymentsVehicles(ctx context.Context, exec boil.ContextExecutor, related ...*InterestPaymentsVehicle) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	for _, rel := range related {
		queries.SetScanner(&rel.OrderID, nil)
		if rel.R != nil {
			rel.R.Order = nil
		}
		if _, err = rel.Update(ctx, exec, boil.Whitelist("order_id")); err != nil {
			return err
		}
	}
	if o.R == nil {
		return nil
	}

	for _, rel := range related {
		for i, ri := range o.R.OrderInterestPaymentsVehicles {
			if rel != ri {
				continue
			}

			ln := len(o.R.OrderInterestPaymentsVehicles)
			if ln > 1 && i < ln-1 {
				o.R.OrderInterestPaymentsVehicles[i] = o.R.OrderInterestPaymentsVehicles[ln-1]
			}
			o.R.OrderInterestPaymentsVehicles = o.R.OrderInterestPaymentsVehicles[:ln-1]
			break
		}
	}

	return nil
}

// AddOrderRedeemOrderVehicles adds the given related objects to the existing relationships
// of the order_vehicle, optionally inserting them as new records.
// Appends related to o.R.OrderRedeemOrderVehicles.
// Sets related.R.Order appropriately.
func (o *OrderVehicle) AddOrderRedeemOrderVehicles(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*RedeemOrderVehicle) error {
	var err error
	for _, rel := range related {
		if insert {
			queries.Assign(&rel.OrderID, o.ID)
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"redeem_order_vehicle\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"order_id"}),
				strmangle.WhereClause("\"", "\"", 2, redeemOrderVehiclePrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.ID}

			if boil.IsDebug(ctx) {
				writer := boil.DebugWriterFrom(ctx)
				fmt.Fprintln(writer, updateQuery)
				fmt.Fprintln(writer, values)
			}
			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			queries.Assign(&rel.OrderID, o.ID)
		}
	}

	if o.R == nil {
		o.R = &orderVehicleR{
			OrderRedeemOrderVehicles: related,
		}
	} else {
		o.R.OrderRedeemOrderVehicles = append(o.R.OrderRedeemOrderVehicles, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &redeemOrderVehicleR{
				Order: o,
			}
		} else {
			rel.R.Order = o
		}
	}
	return nil
}

// SetOrderRedeemOrderVehicles removes all previously related items of the
// order_vehicle replacing them completely with the passed
// in related items, optionally inserting them as new records.
// Sets o.R.Order's OrderRedeemOrderVehicles accordingly.
// Replaces o.R.OrderRedeemOrderVehicles with related.
// Sets related.R.Order's OrderRedeemOrderVehicles accordingly.
func (o *OrderVehicle) SetOrderRedeemOrderVehicles(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*RedeemOrderVehicle) error {
	query := "update \"redeem_order_vehicle\" set \"order_id\" = null where \"order_id\" = $1"
	values := []interface{}{o.ID}
	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, query)
		fmt.Fprintln(writer, values)
	}
	_, err := exec.ExecContext(ctx, query, values...)
	if err != nil {
		return errors.Wrap(err, "failed to remove relationships before set")
	}

	if o.R != nil {
		for _, rel := range o.R.OrderRedeemOrderVehicles {
			queries.SetScanner(&rel.OrderID, nil)
			if rel.R == nil {
				continue
			}

			rel.R.Order = nil
		}
		o.R.OrderRedeemOrderVehicles = nil
	}

	return o.AddOrderRedeemOrderVehicles(ctx, exec, insert, related...)
}

// RemoveOrderRedeemOrderVehicles relationships from objects passed in.
// Removes related items from R.OrderRedeemOrderVehicles (uses pointer comparison, removal does not keep order)
// Sets related.R.Order.
func (o *OrderVehicle) RemoveOrderRedeemOrderVehicles(ctx context.Context, exec boil.ContextExecutor, related ...*RedeemOrderVehicle) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	for _, rel := range related {
		queries.SetScanner(&rel.OrderID, nil)
		if rel.R != nil {
			rel.R.Order = nil
		}
		if _, err = rel.Update(ctx, exec, boil.Whitelist("order_id")); err != nil {
			return err
		}
	}
	if o.R == nil {
		return nil
	}

	for _, rel := range related {
		for i, ri := range o.R.OrderRedeemOrderVehicles {
			if rel != ri {
				continue
			}

			ln := len(o.R.OrderRedeemOrderVehicles)
			if ln > 1 && i < ln-1 {
				o.R.OrderRedeemOrderVehicles[i] = o.R.OrderRedeemOrderVehicles[ln-1]
			}
			o.R.OrderRedeemOrderVehicles = o.R.OrderRedeemOrderVehicles[:ln-1]
			break
		}
	}

	return nil
}

// OrderVehicles retrieves all the records using an executor.
func OrderVehicles(mods ...qm.QueryMod) orderVehicleQuery {
	mods = append(mods, qm.From("\"order_vehicle\""))
	q := NewQuery(mods...)
	if len(queries.GetSelect(q)) == 0 {
		queries.SetSelect(q, []string{"\"order_vehicle\".*"})
	}

	return orderVehicleQuery{q}
}

// FindOrderVehicle retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindOrderVehicle(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*OrderVehicle, error) {
	orderVehicleObj := &OrderVehicle{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"order_vehicle\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, orderVehicleObj)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: unable to select from order_vehicle")
	}

	if err = orderVehicleObj.doAfterSelectHooks(ctx, exec); err != nil {
		return orderVehicleObj, err
	}

	return orderVehicleObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *OrderVehicle) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("models: no order_vehicle provided for insertion")
	}

	var err error
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		if o.UpdatedAt.IsZero() {
			o.UpdatedAt = currTime
		}
	}

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(orderVehicleColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	orderVehicleInsertCacheMut.RLock()
	cache, cached := orderVehicleInsertCache[key]
	orderVehicleInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			orderVehicleAllColumns,
			orderVehicleColumnsWithDefault,
			orderVehicleColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(orderVehicleType, orderVehicleMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(orderVehicleType, orderVehicleMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"order_vehicle\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"order_vehicle\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "models: unable to insert into order_vehicle")
	}

	if !cached {
		orderVehicleInsertCacheMut.Lock()
		orderVehicleInsertCache[key] = cache
		orderVehicleInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the OrderVehicle.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *OrderVehicle) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		o.UpdatedAt = currTime
	}

	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	orderVehicleUpdateCacheMut.RLock()
	cache, cached := orderVehicleUpdateCache[key]
	orderVehicleUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			orderVehicleAllColumns,
			orderVehiclePrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("models: unable to update order_vehicle, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"order_vehicle\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, orderVehiclePrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(orderVehicleType, orderVehicleMapping, append(wl, orderVehiclePrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, values)
	}
	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update order_vehicle row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by update for order_vehicle")
	}

	if !cached {
		orderVehicleUpdateCacheMut.Lock()
		orderVehicleUpdateCache[key] = cache
		orderVehicleUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q orderVehicleQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all for order_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected for order_vehicle")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o OrderVehicleSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("models: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), orderVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"order_vehicle\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, orderVehiclePrimaryKeyColumns, len(o)))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all in orderVehicle slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected all in update all orderVehicle")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *OrderVehicle) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("models: no order_vehicle provided for upsert")
	}
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		o.UpdatedAt = currTime
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(orderVehicleColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	orderVehicleUpsertCacheMut.RLock()
	cache, cached := orderVehicleUpsertCache[key]
	orderVehicleUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			orderVehicleAllColumns,
			orderVehicleColumnsWithDefault,
			orderVehicleColumnsWithoutDefault,
			nzDefaults,
		)

		update := updateColumns.UpdateColumnSet(
			orderVehicleAllColumns,
			orderVehiclePrimaryKeyColumns,
		)

		if updateOnConflict && len(update) == 0 {
			return errors.New("models: unable to upsert order_vehicle, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(orderVehiclePrimaryKeyColumns))
			copy(conflict, orderVehiclePrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"order_vehicle\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(orderVehicleType, orderVehicleMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(orderVehicleType, orderVehicleMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}
	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if errors.Is(err, sql.ErrNoRows) {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "models: unable to upsert order_vehicle")
	}

	if !cached {
		orderVehicleUpsertCacheMut.Lock()
		orderVehicleUpsertCache[key] = cache
		orderVehicleUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single OrderVehicle record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *OrderVehicle) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("models: no OrderVehicle provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), orderVehiclePrimaryKeyMapping)
	sql := "DELETE FROM \"order_vehicle\" WHERE \"id\"=$1"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete from order_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by delete for order_vehicle")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q orderVehicleQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("models: no orderVehicleQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from order_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for order_vehicle")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o OrderVehicleSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(orderVehicleBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), orderVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"order_vehicle\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, orderVehiclePrimaryKeyColumns, len(o))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from orderVehicle slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for order_vehicle")
	}

	if len(orderVehicleAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *OrderVehicle) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindOrderVehicle(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *OrderVehicleSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := OrderVehicleSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), orderVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"order_vehicle\".* FROM \"order_vehicle\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, orderVehiclePrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "models: unable to reload all in OrderVehicleSlice")
	}

	*o = slice

	return nil
}

// OrderVehicleExists checks if the OrderVehicle row exists.
func OrderVehicleExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"order_vehicle\" where \"id\"=$1 limit 1)"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, iD)
	}
	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "models: unable to check if order_vehicle exists")
	}

	return exists, nil
}

// Exists checks if the OrderVehicle row exists.
func (o *OrderVehicle) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	return OrderVehicleExists(ctx, exec, o.ID)
}
